# Algorithmes et structures de données 2020-21

Contenu du cours 4 du 7.10.2020

*****

## Crible d’Eratosthène 

-   Retour sur les tableaux à 1 dimension

## Type article (enregistrement, record) : `struct`

-   Un article permet de regrouper des types de nature différente (appelés champs) comme composant d'un type composé.

-   Exemples de `struct`:
```C
      struct fraction {
          int num;
          int den;
      };

      enum mois {
          jan=1,feb,mar,apr,mai,jun,jul,aug,sep,oct,nov,dec
      };
      struct date {
          int day;
          mois month;
          int year;
      }

      enum sexe {FEM, MASC, AUTRE};
      struct employe {
          char nom[80];
          sexe genre;
          int age;
          float salaire;
      }
```

##  Fonction cube d'un nombre

```C
    int cube(int x) {
        return x*x*x;
    }
```

##  Fonction de parité

```C
    bool est_pair(int n) {
        return n%2 == 0;
    }
```

##  Plus Petit Commun Multiple (PPCM)

-   Fonction PPCM: `int ppcm(int n,int m);`

##  Plus Grand Commun Diviseur (PGCD)

-   Fonction PGCD: `nt pgcd(int n,int m);`

## Paramètres de fonction

-   Dans le langage C, les paramètres des fonctions sont toujours passés par copie.   
    Ainsi, la valeur d'une variable passée en paramètre à une fonction n'est pas modifiée,
    puisque c'est une copie de cette variable qui est passée effectivement à la fonction.   
    Toutes les manipulations effectuées par la fonction le sont donc sur cette copie. 
    Celle-ci est détruite à la fin de l'exécution de la fonction, laissant la variable originelle inchangée.

-   Pour que des modifications puissent subsister après l'exécution, on peut procéder de deux manières :
    1.  en retournant une valeur par la fonction ;
    2.  en passant en paramètre un pointeur : celui-ci donne accès à une
        zone mémoire hors de la portée (scope) de la fonction, zone qui
        peut donc être modifiée durablement.

- Fonction d'incrément

```C
      void sans_effet(int x) {
          x++;
      }
      void increment(int* x) {
          (*x)++;
      }

      void main() {
          int a = 2;
          sans_effet(a);
          printf("a=%d",a); // imprime 2, valeur de a inchangée
          increment(&a);
          printf(\"a=%d\",a); // imprime 3
      }
```

## Zones d'allocation mémoire

-   Un programme utilise deux types de zone mémoire lors de son exécution pour stocker les variables : la pile et le tas.   
-   A l'exécution d'un programme, les allocations de variables :
    1.  sur la pile, sont faites par le système d'exploitation
        -   dans ce cas, on parle de variables statiques
    2.  sur le tas, sont de la responsabilité de la programmeuse via un appel à la fonction `malloc()`
        -   dans ce cas, on parle de variables dynamiques
-   La désallocation d'une variable statique survient lors de la sortie de sa portée (scope) et est donc automatique.
-   Une variable dynamique doit être explicitement désallouée par la programmeuse avec un appel à la fonction `free()`.
-   Il y a parfois une petite confusion entre la zone mémoire où réside un pointeur et celle où se situe l'espace pointé par le pointeur.
-   Par exemple, l’instruction   
    `char* ptr_ch = malloc(3*sizeof(char));`   
    alloue un espace sur le tas pour 3 caractères, alors que la variable `ptr_ch` est allouée sur la pile.



## Pseudo-code du tri par sélection

```
    procedure tri_selection(tableau t[0..n­-1])
    begin
        for i = 0 to n-­2 do
            ind_min := index_min(t[i..n-­1])
            if t[ind_min] ≠ t[i] then
                echanger(t[i],t[ind_min])
            end if
        end for
    end tri_selection
```
